package com.fjhx.victoriatourist.controller.excess;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.victoriatourist.entity.excess.dto.ExcessGoodsDetailsDto;
import com.fjhx.victoriatourist.entity.excess.dto.ExcessGoodsDetailsSelectDto;
import com.fjhx.victoriatourist.entity.excess.vo.ExcessGoodsDetailsVo;
import com.fjhx.victoriatourist.service.excess.ExcessGoodsDetailsService;
import com.ruoyi.common.core.domain.BaseSelectDto;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * <p>
 * 多货登记明细 前端控制器
 * </p>
 *
 * @author 
 * @since 2024-03-27
 */
@RestController
@RequestMapping("/excessGoodsDetails")
public class ExcessGoodsDetailsController {

    @Autowired
    private ExcessGoodsDetailsService excessGoodsDetailsService;

    /**
     * 多货登记明细列表
     */
    @PostMapping("/list")
    public List<ExcessGoodsDetailsVo> list(@RequestBody ExcessGoodsDetailsSelectDto dto) {
        return excessGoodsDetailsService.getList(dto);
    }

    /**
     * 多货登记明细分页
     */
    @PostMapping("/page")
    public Page<ExcessGoodsDetailsVo> page(@RequestBody ExcessGoodsDetailsSelectDto dto) {
        return excessGoodsDetailsService.getPage(dto);
    }

    /**
     * 多货登记明细明细
     */
    @PostMapping("/detail")
    public ExcessGoodsDetailsVo detail(@RequestBody BaseSelectDto dto) {
        return excessGoodsDetailsService.detail(dto.getId());
    }

    /**
     * 多货登记明细新增
     */
    @PostMapping("/add")
    public void add(@RequestBody ExcessGoodsDetailsDto excessGoodsDetailsDto) {
        excessGoodsDetailsService.add(excessGoodsDetailsDto);
    }

    /**
     * 多货登记明细编辑
     */
    @PostMapping("/edit")
    public void edit(@RequestBody ExcessGoodsDetailsDto excessGoodsDetailsDto) {
        excessGoodsDetailsService.edit(excessGoodsDetailsDto);
    }

    /**
     * 多货登记明细删除
     */
    @PostMapping("/delete")
    public void delete(@RequestBody BaseSelectDto dto) {
        excessGoodsDetailsService.delete(dto.getId());
    }


    @PostMapping("/backGoods")
    public void backGoods(@RequestBody ExcessGoodsDetailsDto dto) {
        excessGoodsDetailsService.backGoods(dto);
    }

    @PostMapping("/inStock")
    public void inStock(@RequestBody List<Long> excessGoodsDetailsIds) {
        excessGoodsDetailsService.inStock(excessGoodsDetailsIds);
    }

}
