package com.fjhx.victoriatourist.service.excess.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fjhx.common.utils.Assert;
import com.fjhx.victoriatourist.entity.excess.dto.ExcessGoodsRegisterDto;
import com.fjhx.victoriatourist.entity.excess.dto.ExcessGoodsRegisterSelectDto;
import com.fjhx.victoriatourist.entity.excess.po.ExcessGoodsDetails;
import com.fjhx.victoriatourist.entity.excess.po.ExcessGoodsRegister;
import com.fjhx.victoriatourist.entity.excess.vo.ExcessGoodsRegisterVo;
import com.fjhx.victoriatourist.mapper.excess.ExcessGoodsRegisterMapper;
import com.fjhx.victoriatourist.service.excess.ExcessGoodsDetailsService;
import com.fjhx.victoriatourist.service.excess.ExcessGoodsRegisterService;
import com.ruoyi.common.utils.wrapper.IWrapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 多货登记临时表 服务实现类
 * </p>
 *
 * @author
 * @since 2024-03-27
 */
@Service
public class ExcessGoodsRegisterServiceImpl extends ServiceImpl<ExcessGoodsRegisterMapper, ExcessGoodsRegister> implements ExcessGoodsRegisterService {

    @Autowired
    private ExcessGoodsDetailsService excessGoodsDetailsService;



    private IWrapper<ExcessGoodsRegister> getWrapper(ExcessGoodsRegisterSelectDto dto) {
        IWrapper<ExcessGoodsRegister> wrapper = getWrapper();

        wrapper.orderByDesc("egr", ExcessGoodsRegister::getId);
        return wrapper;
    }

    @Override
    public List<ExcessGoodsRegisterVo> getList(ExcessGoodsRegisterSelectDto dto) {
        IWrapper<ExcessGoodsRegister> wrapper = getWrapper(dto);
        List<ExcessGoodsRegisterVo> list = this.baseMapper.getList(wrapper);
        return list;
    }

    @Override
    public Page<ExcessGoodsRegisterVo> getPage(ExcessGoodsRegisterSelectDto dto) {
        IWrapper<ExcessGoodsRegister> wrapper = getWrapper(dto);
        Page<ExcessGoodsRegisterVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        List<ExcessGoodsRegisterVo> records = page.getRecords();
        if (ObjectUtil.isEmpty(records)) {
            return page;
        }
        return page;
    }

    @Override
    public ExcessGoodsRegisterVo detail(Long id) {
        ExcessGoodsRegister ExcessGoodsRegister = this.getById(id);
        ExcessGoodsRegisterVo result = BeanUtil.toBean(ExcessGoodsRegister, ExcessGoodsRegisterVo.class);
        return result;
    }

    @Override
    public void add(ExcessGoodsRegisterDto excessGoodsRegisterDto) {
        ExcessGoodsDetails excessGoodsDetails = excessGoodsDetailsService.getById(excessGoodsRegisterDto.getExcessGoodsDetailsId());
        Assert.notEmpty(excessGoodsDetails,"查询不到多货产品id");
        excessGoodsRegisterDto.setStockWaitId(excessGoodsDetails.getStockWaitId());
        this.save(excessGoodsRegisterDto);
    }

    @Override
    public void edit(ExcessGoodsRegisterDto excessGoodsRegisterDto) {
        this.updateById(excessGoodsRegisterDto);
    }

    @Override
    public void delete(Long id) {
        this.removeById(id);
    }

}
