package com.fjhx.wms.service.stock;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.wms.entity.stock.dto.StockCheckRegisterDto;
import com.fjhx.wms.entity.stock.dto.StockCheckRegisterSelectDto;
import com.fjhx.wms.entity.stock.po.StockCheckRegister;
import com.fjhx.wms.entity.stock.vo.StockCheckRegisterVo;
import com.ruoyi.common.core.service.BaseService;
import com.ruoyi.common.utils.wrapper.IWrapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * <p>
 * 库存盘点登记 服务类
 * </p>
 *
 * @author 
 * @since 2024-03-26
 */
public interface StockCheckRegisterService extends BaseService<StockCheckRegister> {

    /**
     * 库存盘点登记列表
     */
    List<StockCheckRegisterVo> getList(StockCheckRegisterSelectDto dto);

    List<StockCheckRegisterVo> getList(@Param("ew") IWrapper<StockCheckRegister> wrapper);

    /**
     * 库存盘点登记分页
     */
    Page<StockCheckRegisterVo> getPage(StockCheckRegisterSelectDto dto);

    /**
     * 库存盘点登记明细
     */
    StockCheckRegisterVo detail(Long id);

    /**
     * 库存盘点登记新增
     */
    void add(StockCheckRegisterDto stockCheckRegisterDto);

    /**
     * 库存盘点登记编辑
     */
    void edit(StockCheckRegisterDto stockCheckRegisterDto);

    /**
     * 库存盘点登记删除
     */
    void delete(Long id);

}
