package com.fjhx.wms.service.stock.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fjhx.common.utils.Assert;
import com.fjhx.wms.entity.stock.dto.StockWaitDetailsCheckDto;
import com.fjhx.wms.entity.stock.dto.StockWaitDetailsCheckSelectDto;
import com.fjhx.wms.entity.stock.po.StockWaitDetails;
import com.fjhx.wms.entity.stock.po.StockWaitDetailsCheck;
import com.fjhx.wms.entity.stock.vo.StockWaitDetailsCheckVo;
import com.fjhx.wms.mapper.stock.StockWaitDetailsCheckMapper;
import com.fjhx.wms.service.stock.StockWaitDetailsCheckService;
import com.fjhx.wms.service.stock.StockWaitDetailsService;
import com.ruoyi.common.utils.wrapper.IWrapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 待入库清点 服务实现类
 * </p>
 *
 * @author
 * @since 2024-03-25
 */
@Service
public class StockWaitDetailsCheckServiceImpl extends ServiceImpl<StockWaitDetailsCheckMapper, StockWaitDetailsCheck> implements StockWaitDetailsCheckService {

    private final StockWaitDetailsService stockWaitDetailsService;

    @Autowired
    public StockWaitDetailsCheckServiceImpl(StockWaitDetailsService stockWaitDetailsService) {
        this.stockWaitDetailsService = stockWaitDetailsService;
    }

    @Override
    public List<StockWaitDetailsCheckVo> getList(StockWaitDetailsCheckSelectDto dto) {

        IWrapper<StockWaitDetailsCheck> wrapper = getCommWrapper(dto);
        ;
        List<StockWaitDetailsCheckVo> list = this.baseMapper.getList(wrapper);
        return list;
    }

    @Override
    public List<StockWaitDetailsCheckVo> getList(IWrapper<StockWaitDetailsCheck> wrapper) {
        List<StockWaitDetailsCheckVo> list = this.baseMapper.getList(wrapper);
        return list;
    }

    private IWrapper<StockWaitDetailsCheck> getCommWrapper(StockWaitDetailsCheckSelectDto dto) {
        IWrapper<StockWaitDetailsCheck> wrapper = getWrapper();

        wrapper.eq("swdc", StockWaitDetailsCheck::getStockWaitId, dto.getStockWaitId());
        wrapper.eq("swdc", StockWaitDetailsCheck::getStockWaitDetailsId, dto.getStockWaitDetailsId());

        wrapper.orderByDesc("swdc", StockWaitDetailsCheck::getCreateTime);
        wrapper.orderByDesc("swdc", StockWaitDetailsCheck::getId);
        return wrapper;
    }

    @Override
    public Page<StockWaitDetailsCheckVo> getPage(StockWaitDetailsCheckSelectDto dto) {
        IWrapper<StockWaitDetailsCheck> wrapper = getCommWrapper(dto);
        Page<StockWaitDetailsCheckVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }

    @Override
    public StockWaitDetailsCheckVo detail(Long id) {
        StockWaitDetailsCheck StockWaitDetailsCheck = this.getById(id);
        StockWaitDetailsCheckVo result = BeanUtil.toBean(StockWaitDetailsCheck, StockWaitDetailsCheckVo.class);
        return result;
    }

    @Override
    public void add(StockWaitDetailsCheckDto dto) {
        StockWaitDetails stockWaitDetails = stockWaitDetailsService.getById(dto.getStockWaitDetailsId());
        Assert.notEmpty(stockWaitDetails, "查询不到待入库明细信息");
        dto.setStockWaitId(stockWaitDetails.getStockWaitId());
        this.save(dto);
    }

    @Override
    public void edit(StockWaitDetailsCheckDto stockWaitDetailsCheckDto) {
        this.updateById(stockWaitDetailsCheckDto);
    }

    @Override
    public void delete(Long id) {
        this.removeById(id);
    }

}
